%define anolis_release 1
%bcond_with perl_CPAN_enables_gnupg_test
%bcond_with perl_CPAN_enables_optional_test

Name:           perl-CPAN
Version:        2.36
Release:        %{anolis_release}%{?dist}
Summary:        Query, download and build perl modules from CPAN sites
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/CPAN
Source0:        https://cpan.metacpan.org/authors/id/A/AN/ANDK/CPAN-%{version}.tar.gz
Source1:        test


BuildArch:      noarch
BuildRequires:  coreutils, findutils, make
BuildRequires:  perl-generators, perl-interpreter
BuildRequires:  perl(Config), perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Basename), perl(File::Path)
BuildRequires:  perl(strict), perl(vars), perl(vars), perl(File::Spec)
BuildRequires:  perl(Archive::Tar) >= 1.50
%if !%{defined perl_bootstrap}
BuildRequires:  perl(Archive::Zip)
%endif
BuildRequires: perl(autouse) perl(base) perl(Carp) perl(constant)
BuildRequires: perl(Compress::Zlib) perl(CPAN::Meta::Requirements) >= 2.121
BuildRequires: perl(Cwd) perl(Data::Dumper) perl(DirHandle) perl(Dumpvalue)
BuildRequires: perl(Errno) perl(Exporter) perl(Fcntl) perl(File::Copy)
BuildRequires: perl(File::Find) perl(File::Spec::Functions) perl(File::Temp) >= 0.16
BuildRequires: perl(FileHandle) perl(Getopt::Std) perl(HTTP::Tiny) >= 0.005
BuildRequires: perl(if) perl(lib) perl(Net::Ping) perl(overload) perl(POSIX)
BuildRequires: perl(Safe) perl(Sys::Hostname) perl(Term::ReadLine)
BuildRequires: perl(Text::ParseWords) perl(Text::Wrap) perl(warnings)
#%%if !%%{defined perl_bootstrap}
#%%endif
BuildRequires:  perl(CPAN::Meta) >= 2.110350, perl(Digest::SHA)
%if !%{defined perl_bootstrap}
BuildRequires:  perl(Module::Build)
%endif

BuildRequires:  perl(blib), perl(File::Which), perl(FindBin)
BuildRequires:  perl(Pod::Usage), perl(Test::More), perl(version)


%if %{with perl_CPAN_enables_optional_test}
%if %{with perl_CPAN_enables_gnupg_test}
BuildRequires:  %{_bindir}/gpg
%endif
%if !%{defined perl_bootstrap}
BuildRequires:  perl(Expect)
%endif
BuildRequires:  perl(Hash::Util)
%if !%{defined perl_bootstrap}
%if %{with perl_CPAN_enables_gnupg_test}
BuildRequires:  perl(Module::Signature) >= 0.66
%endif
BuildRequires:  perl(Perl::Version)
%endif
BuildRequires:  perl(Pod::Perldoc::ToMan)
%if %{with perl_CPAN_enables_gnupg_test}
BuildRequires:  perl(Socket)
%endif
%if !%{defined perl_bootstrap}
BuildRequires:  perl(Sort::Versions), perl(Test::Pod) >= 1.00
BuildRequires:  perl(Test::Pod::Coverage) >= 0.18, perl(YAML) >= 0.60
%endif
%endif

Requires:       make, perl
Requires:       perl(Archive::Tar) >= 1.50
%if !%{defined perl_bootstrap}
Recommends:     perl(CPAN::DistnameInfo)
%endif
Requires:       perl(CPAN::Meta::Requirements) >= 2.121, perl(Data::Dumper)
%if !%{defined perl_bootstrap}
Requires:       perl(Devel::Size)
%endif
Requires:       perl(ExtUtils::Manifest)
%if !%{defined perl_bootstrap}
Requires:       perl(File::HomeDir) >= 0.65
%endif
Requires:       perl(File::Temp) >= 0.16, perl(lib)
Requires:       perl(lib)
%if !%{defined perl_bootstrap}
Suggests:       perl(Log::Log4perl)
%endif
Requires:       perl(Net::Config), perl(Net::FTP), perl(POSIX), perl(Term::ReadLine)
Requires:       perl(Time::Local)
%if !%{defined perl_bootstrap}
Requires:       perl(URI), perl(URI::Escape)
%endif
Requires:       perl(User::pwent)
%if !%{defined perl_bootstrap}
Requires:       perl(Archive::Zip), perl(Compress::Bzip2), perl(CPAN::Meta) >= 2.110350
%endif
Requires:       perl(Compress::Zlib), perl(Digest::MD5), perl(Digest::SHA)
Requires:       perl(Dumpvalue), perl(ExtUtils::CBuilder)
%if ! %{defined perl_bootstrap}
Requires:       perl(Module::Signature)
%endif
%if ! %{defined perl_bootstrap}
Requires:       perl(local::lib)
%endif
%if ! %{defined perl_bootstrap}
Requires:       perl(Module::Build)
%endif
Recommends:     perl(Pod::Perldoc)
%if ! %{defined perl_bootstrap}
Recommends:     perl(Term::ReadKey)
Requires:       perl(Text::Glob)
Suggests:       perl(Text::Levenshtein::Damerau::XS), perl(YAML::Syck)
%endif
Provides:       cpan = %{version}

%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(Mac::BuildTools\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(CPAN::Meta::Requirements\\)
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}
%global __requires_exclude %{__requires_exclude}|^perl\\(CPAN::MyConfig\\)
%global __requires_exclude %{__requires_exclude}|^perl\\(local_utils\\)

Patch0:         CPAN-2.18-Attemp-to-create-site-library-directories-on-first-t.patch
Patch1:         CPAN-2.18-Replace-configuration-directory-string-with-a-marke.patch

%description
CPAN (Comprehensive Perl Archive Network) is a comprehensive repository of
Perl software and documentation that serves as a centralized resource for the
Perl community. This repository comprises thousands of modules, libraries,
frameworks, and tools that are available to be downloaded and used free of charge.
CPAN offers a convenient way to search, install, and manage Perl modules, enabling
developers to rapidly and efficiently incorporate new functionality into their
Perl applications. Additionally, CPAN hosts a wealth of documentation, tutorials,
and other resources that can aid developers in honing their Perl skills and keeping
up-to-date with the latest advancements in the Perl language.

The CPAN module automates or at least simplifies the make and install of
perl modules and extensions. It includes some primitive searching
capabilities and knows how to use LWP, HTTP::Tiny, Net::FTP and certain
external download clients to fetch distributions from the net.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       perl-Test-Harness

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n CPAN-%{version} -p1

find -type f -exec perl -i -pe 's/XCPANCONFIGNAMEX/cpan/g' {} \;
rm -r ./inc/*
perl -i -ne 'print $_ unless m{^inc/}' MANIFEST

for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*


mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t distroprefs %{buildroot}%{_libexecdir}/%{name}
rm %{buildroot}%{_libexecdir}/%{name}/t/51pod.t
rm %{buildroot}%{_libexecdir}/%{name}/t/03pkgs.t
rm %{buildroot}%{_libexecdir}/%{name}/t/04clean_load.t
rm %{buildroot}%{_libexecdir}/%{name}/t/31sessions.t

perl -i -ple 's{-Mblib}{}' %{buildroot}%{_libexecdir}/%{name}/t/97-run.t
perl -i -ple 's{-Mblib}{}' %{buildroot}%{_libexecdir}/%{name}/t/97-return_values.t
mkdir -p %{buildroot}%{_libexecdir}/%{name}/blib/script
ln -s %{_bindir}/cpan %{buildroot}%{_libexecdir}/%{name}/blib/script

cp %{SOURCE1} %{buildroot}%{_libexecdir}/%{name}/test
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
unset AUTHOR_TEST CPAN_EXPECT_TIMEOUT CPAN_RUN_SHELL_TEST_WITHOUT_EXPECT \
    ftp_proxy http_proxy no_proxy \
    PERL5_CPAN_IS_RUNNING PERL5_CPAN_IS_RUNNING_IN_RECURSION PERL_CORE VERBOSE
make test

%files
%{_bindir}/*
%{perl_vendorlib}/*
%{_mandir}/man1/*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}

%files doc
%doc Changes PAUSE*.pub README Todo

%changelog
* Mon Jul 31 2023 Funda Wang <fundawang@yeah.net> - 2.36-1
- New version 2.36

* Tue Apr 11 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> - 2.34-4
- Optimize spec file

* Wed Feb 08 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.34-3
- remove versioned MODULE_COMPAT_ requires
- rebuild with perl_bootstrap disabled

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.34-2
- rebuild with perl 5.36.0

* Wed Apr 20 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.34-1
- init from upstream
